/***************************************************************************************************
THis code computes the cross section variance of stock returns  from CRSP
This variable is saved as cm2_ew in forbes400_aggregate.dta
***************************************************************************************************/

use "$DatabasePath/data/firms/crsp/msenames", clear
egen t = max(inlist(shrcd, 10, 11) & inlist(hexcd, 1, 2, 3)), by(permno)
drop if t == 0
gen year = year(namedt)
bys permno (year): keep if _n == 1
rename year minyear
keep permno minyear naics siccd shrcd hexcd
sort permno
tempfile temp
save `temp'

use "$DatabasePath/data/firms/crsp/msf", clear
sort permno
merge m:1 permno using `temp', sorted keep(matched)
gen datem = mofd(date)
replace datem = datem - 9
gen year = year(dofm(datem)) + 1
egen count = sum(!missing(ret)), by(permno year)
gen logR = log(1 + ret)
gen mktcap = shrout * abs(altprc)
/* Rt is the return from October t to October t + 1 */
collapse (sum) logR (last) mktcap, by(permno year count minyear naics siccd) fast
gen R = exp(logR) 
keep if count == 12
winsor2 logR, by(year) replace
collapse (sd) sd_ew = logR, by(year)
gen cm2_ew = sd_ew^2
